#!/usr/bin/python
# coding: UTF-8
#【GIMP】ディフュージョンフィルター( http://www.nicovideo.jp/watch/sm23454871 , http://dic.pixiv.net/a/%E3%83%87%E3%82%A3%E3%83%95%E3%83%A5%E3%83%BC%E3%82%B8%E3%83%A7%E3%83%B3 )をスクリプトにしてみた

from gimpfu import *

def diffusion_nico(img, draw,br1,br2):
	lay=pdb.gimp_image_get_active_layer(img)

	lay1=pdb.gimp_layer_copy(lay,FALSE)
	lay2=pdb.gimp_layer_copy(lay,FALSE)
	lay3=pdb.gimp_layer_copy(lay,FALSE)
	lay4=pdb.gimp_layer_copy(lay,FALSE)

	pdb.gimp_image_insert_layer(img,lay4,None,-1)
	pdb.gimp_image_insert_layer(img,lay3,None,-1)
	pdb.gimp_image_insert_layer(img,lay2,None,-1)
	pdb.gimp_image_insert_layer(img,lay1,None,-1)

	pdb.plug_in_gauss(img,lay1,br2,br2,1) # RLE=1, ガウンシアンぼかし
	pdb.plug_in_gauss(img,lay3,br1,br1,1) # RLE=1, ガウンシアンぼかし
	pdb.gimp_layer_set_mode(lay1,DIVIDE_MODE) # レイヤーモードを除算
	pdb.gimp_layer_set_mode(lay3,DIVIDE_MODE) # レイヤーモードを除算

	lay5=pdb.gimp_image_merge_down(img,lay1,0) # 下のレイヤーと統合
	lay6=pdb.gimp_image_merge_down(img,lay3,0) # 下のレイヤーと統合

	lay5.name='DF nic ぼかし-乗算'
	lay6.name='DF nic ぼかし-除算'

	pdb.gimp_layer_set_mode(lay5,MULTIPLY_MODE) # レイヤーモードを乗算
	pdb.gimp_layer_set_mode(lay6,DIVIDE_MODE) # レイヤーモードを除算

	pdb.gimp_image_set_active_layer(img,lay)


def diffusion_pixiv(img,draw,br):
	lay=pdb.gimp_image_get_active_layer(img)

	lay1=pdb.gimp_layer_copy(lay,FALSE)
	pdb.gimp_image_insert_layer(img,lay1,None,-1)
	pdb.gimp_layer_set_mode(lay1,MULTIPLY_MODE) # レイヤーモードを乗算
	lay1.name='DF pix 乗算'

	lay2=pdb.gimp_layer_new_from_visible(img,img,"lay2") # 可視部分をレイヤーに
	pdb.gimp_image_insert_layer(img,lay2,None,-1)

	pdb.plug_in_gauss(img,lay2,br,br,1) # RLE=1, ガウンシアンぼかし
	pdb.gimp_layer_set_mode(lay2,SCREEN_MODE) # レイヤーモードをスクリーン
	lay2.name='DF pix ぼかしスクリーン'

	lay3=pdb.gimp_layer_copy(lay,FALSE)
	pdb.gimp_image_insert_layer(img,lay3,None,-1)
	pdb.gimp_layer_set_mode(lay3,LIGHTEN_ONLY_MODE) # レイヤーモードを比較（明）
	lay3.name='DF pix 比較（明）'

	pdb.gimp_image_set_active_layer(img,lay)


def diffusion(img, draw,type,br1,br2):
	pdb.gimp_undo_push_group_start(img)
	if type==0:
		diffusion_nico(img, draw,br1,br2)
	else:
		diffusion_pixiv(img,draw,br1)
	pdb.gimp_undo_push_group_end(img)


register(
        "python_fu_diffusion_filter",
        "Diffusion Filter(Type PixivはBlur Radius 2を使わない)",
        "Diffusion Filter",
        "amekujira",
        "amekujira",
        "2015",
        "<Image>/Filters/Blur/ディフュージョン",
        "RGB*, GRAY*",
        [
      (PF_RADIO, "type", "Type:", 0, (("NicoNico",0), ("Pixiv",1)) ),
      (PF_SPINNER, "br1", "Blur Radius 1", 30, (1, 500, 1)),
      (PF_SPINNER, "br2", "Blur Radius 2", 2, (1, 500, 1)),
	],
        [],
        diffusion)

main()
