﻿#!/usr/bin/python
# coding: UTF-8
#レイヤーに分割

from gimpfu import *
import math

def divide(img=None, lay_base=None, divide_width=200, divide_height=200, num_tiles_x=0, num_tiles_y=0, reset_offset=True):
 if not img:
  img=gimp.image_list()[0]
 if not lay_base:
  lay_base=img.active_layer
 pdb.gimp_undo_push_group_start(img)
 w=lay_base.width
 h=lay_base.height
 if num_tiles_x > 0:
  divide_width = int(math.ceil(w / num_tiles_x))
 if num_tiles_y > 0:
  divide_height = int(math.ceil(h/ num_tiles_y))
 if divide_width >= w:
  divide_width = w
 if divide_height >= h:
  divide_height = h
 y=0
 while y < h:
  x=0
  while x < w:
   lay_cp=lay_base.copy()
   pos=pdb.gimp_image_get_layer_position(img, lay_base)
   img.add_layer(lay_cp, pos) #後ろからレイヤーを挿入
   pdb.gimp_layer_resize(lay_cp, divide_width, divide_height, -x, -y)
   if reset_offset: # 左上に移動
    pdb.gimp_layer_translate(lay_cp, -lay_cp.offsets[0], -lay_cp.offsets[1])
   x=x+divide_width
  y=y+divide_height
 img.remove_layer(lay_base)
 pdb.gimp_image_resize_to_layers(img) #キャンパスサイズをレイヤーに合わせる
 pdb.gimp_undo_push_group_end(img)


register(
        "python_fu_divide_to_layers",
        "レイヤーに分割",
        "divide a layer to tiles",
        "amekujira",
        "amekujira",
        "2015",
        "<Image>/Layer/レイヤーに分割",
        "*",
        [
        (PF_SPINNER, "divide_width", "１つ辺りの横長", 200, (1, 4096, 1)),
        (PF_SPINNER, "divide_height", "１つ辺りの縦長", 200, (1, 4096, 1)),
        (PF_SPINNER, "num_x", "横の分割数", 0, (0, 10, 1)),
        (PF_SPINNER, "num_y", "縦の分割数", 0, (0, 10, 1)),
        (PF_BOOL,   "reset_offset", "左上に移動", True),
	],
        [],
        divide)

main()
