#!/usr/bin/python
# coding: UTF-8
#フェルト地ロゴをスクリプトにしてみた

from gimpfu import *

def felt_logo_effect(img,lay_text1,font_grow,feather_radius,font_shrink,stitch_width, stitch_dist1, stitch_dist2,hue,saturation,lightness,num_dodgeburn):

	#不透明部分を選択
	pdb.gimp_image_select_item(img,CHANNEL_OP_REPLACE,lay_text1)

	#レイヤーを削除
	pdb.gimp_layer_set_visible(lay_text1, 0) #レイヤーを見えなくする

	#選択部分を拡大
	pdb.gimp_selection_grow(img,font_grow)

	#選択範囲の境界をぼかす
	pdb.gimp_selection_feather(img,feather_radius)

	#選択範囲を明確化
	pdb.gimp_selection_sharpen(img)

	lay_text=pdb.gimp_layer_new(img,img.width,img.height,RGB_IMAGE,'text',100,NORMAL_MODE)
	#透明で塗る
	pdb.gimp_layer_add_alpha(lay_text)
	pdb.gimp_drawable_fill(lay_text, TRANSPARENT_FILL)
	pdb.gimp_image_insert_layer(img,lay_text,None,0)

	#パターン(Ice)で塗る
	pdb.gimp_context_set_pattern('Ice')
	pdb.gimp_edit_fill(lay_text,PATTERN_FILL)

	#着色（色相、彩度、輝度）
	pdb.gimp_colorize(lay_text,hue,saturation,lightness)

	#選択部分を縮小
	pdb.gimp_selection_shrink(img,font_shrink)

	#layer追加
	lay_line=pdb.gimp_layer_new(img,img.width,img.height,RGB_IMAGE,'line',100,NORMAL_MODE)
	pdb.gimp_layer_add_alpha(lay_line)
	pdb.gimp_drawable_fill(lay_line, WHITE_FILL)
	pdb.gimp_image_insert_layer(img,lay_line,None,0)

	pdb.plug_in_sel2path(img,None) #選択範囲をパスに
	pdb.gimp_selection_none(img) #選択を解除
	v=pdb.gimp_image_get_active_vectors(img) #パス(Active Vectors?)を入手

	#カスタム破線っぽく破線を描画
	pdb.gimp_context_set_brush('1. Pixel') # 破線は1ピクセルのブラシ（ブラシの仕様が変わったら動かなくなるとこ）
	pdb.gimp_context_set_brush_size(stitch_width)
	for sid in pdb.gimp_vectors_get_strokes(v)[-1]:
		leng=pdb.gimp_vectors_stroke_get_length(v,sid,0.2)
		dist=0
		valid=TRUE;
		while dist<leng and valid:
			(x1,y1,s,valid)=pdb.gimp_vectors_stroke_get_point_at_dist(v,sid,dist,0.2)
			dist = dist + stitch_dist1
			(x2,y2,s,valid)=pdb.gimp_vectors_stroke_get_point_at_dist(v,sid,dist,0.2)
			dist = dist + stitch_dist2
			if valid: pdb.gimp_paintbrush_default(lay_line,4,(x1,y1,x2,y2))

	#レイヤーの複製
	lay_line_bump=pdb.gimp_layer_copy(lay_line,FALSE)
	pdb.gimp_image_insert_layer(img,lay_line_bump,None,0)

	pdb.plug_in_gauss(img,lay_line_bump,11,11,1) # RLE=1, ガウンシアンぼかし
	pdb.plug_in_bump_map(img,lay_text,lay_line_bump,120,44.87,3,0,0,0,17,TRUE,FALSE,0) #LINEAR=0, バンプマップ

	#レイヤーを削除
	pdb.gimp_image_remove_layer(img,lay_line_bump)

	pdb.plug_in_colortoalpha(img,lay_line,(255,255,255)) #白色を透明度に
	pdb.gimp_layer_set_lock_alpha(lay_line,TRUE) #透明を保護

	#パターン(CorkBord)で塗る
	pdb.gimp_context_set_pattern('Cork board')
	pdb.gimp_edit_fill(lay_line,PATTERN_FILL)

	pdb.script_fu_add_bevel(img,lay_line,5,0,0) #ベベル(bevel)の装飾

	#layer追加
	lay_kumo=pdb.gimp_layer_new(img,img.width,img.height,RGB_IMAGE,'kumo',100,NORMAL_MODE)
	pdb.gimp_layer_add_alpha(lay_kumo)
	pdb.gimp_image_insert_layer(img,lay_kumo,None,0)

	#下塗り→雲→ソリッドノイズ
	pdb.plug_in_solid_noise(img,lay_kumo,FALSE,FALSE,0,15,6.6,4.0)

	pdb.gimp_image_select_item(img,CHANNEL_OP_REPLACE,lay_text) #不透明部分を選択
	pdb.gimp_selection_invert(img) #選択範囲を反転
	pdb.gimp_edit_clear(lay_kumo) #選択範囲を削除
	pdb.gimp_selection_none(img) #選択を解除

	pdb.gimp_layer_set_mode(lay_kumo,DIFFERENCE_MODE) # レイヤーモードを差の絶対値
	pdb.gimp_layer_set_opacity(lay_kumo,35.7) # 不透明度を設定

	pdb.script_fu_add_bevel(img,lay_text,12,0,0) #ベベル(bevel)の装飾
	pdb.script_fu_drop_shadow(img,lay_text,8,8,15,(0,0,0),30,1) #ドロップシャドウ

	#暗室ツール(見ながら手作業した方がいいのだが)
	pdb.gimp_context_set_brush('2. Hardness 050') # 暗室は丸いブラシで
	pdb.gimp_context_set_brush_size(500)
	import random
	lay_drop=pdb.gimp_image_get_layer_by_name(img,'Drop Shadow') #'Drop Shadow'レイヤーを探す
	(x0,y0)=pdb.gimp_drawable_offsets(lay_drop)
	w=lay_drop.width+400
	h=lay_drop.height+400
	num_dodgeburn=int(num_dodgeburn) # range(x)でエラーが出るので
	for i in range(num_dodgeburn):
		x=x0-200+random.random()*w
		y=y0-200+random.random()*h
		pdb.gimp_dodgeburn_default(lay_text,2,(x,y,x+1,y+1))


def felt_logo_alpha(img,draw,font_grow,feather_radius,font_shrink,stitch_width, stitch_dist1, stitch_dist2,hue,saturation,lightness,num_dodgeburn):

	gimp.context_push()
	pdb.gimp_undo_push_group_start(img)

	pdb.gimp_context_set_defaults() # デフォルト値を設定
	pdb.gimp_context_set_foreground((0,0,0)) #描画色を黒
	pdb.gimp_context_set_background((255,255,255)) #背景色を白

	felt_logo_effect(img,draw,font_grow,feather_radius,font_shrink,stitch_width, stitch_dist1, stitch_dist2,hue,saturation,lightness,num_dodgeburn)

	pdb.gimp_undo_push_group_end(img)
	gimp.context_pop()
	pdb.gimp_displays_flush()


def felt_logo(string,font,font_size,font_angle,font_grow,feather_radius,font_shrink,stitch_width, stitch_dist1, stitch_dist2,hue,saturation,lightness,num_dodgeburn):
	img=pdb.gimp_image_new(256,256,RGB) #image作成

	gimp.context_push()
	pdb.gimp_undo_push_group_start(img)

	pdb.gimp_context_set_defaults() # デフォルト値を設定
	pdb.gimp_context_set_foreground((0,0,0)) #描画色を黒
	pdb.gimp_context_set_background((255,255,255)) #背景色を白

	#テキストレイヤーを追加
	lay_text1=pdb.gimp_text_fontname(img,None,0,0,string,font_size/4,TRUE,font_size,PIXELS,font)

	#テキストレイヤーを回転
	pdb.gimp_item_transform_rotate(lay_text1,font_angle*3.14/180,TRUE,lay_text1.width/2,lay_text1.height/2)

	#テキストレイヤーに合わせてイメージサイズを変更
	pdb.gimp_image_resize(img,lay_text1.width,lay_text1.height,-lay_text1.offsets[0],-lay_text1.offsets[1])

	#背景レイヤーを追加
	lay_bg=pdb.gimp_layer_new(img,img.width,img.height,RGB_IMAGE,'background',100,NORMAL_MODE)
	pdb.gimp_image_insert_layer(img,lay_bg,None,1)

	#真っ黒なので白で塗る
	pdb.gimp_drawable_fill(lay_bg, WHITE_FILL)

	felt_logo_effect(img,lay_text1,font_grow,feather_radius,font_shrink,stitch_width, stitch_dist1, stitch_dist2,hue,saturation,lightness,num_dodgeburn)

	#表示
	pdb.gimp_display_new(img)

	pdb.gimp_undo_push_group_end(img)
	gimp.context_pop()
	pdb.gimp_displays_flush()


register(
        "python_fu_felt_logo",
        "フェルト地ロゴ",
        "フェルト地ロゴ",
        "amekujira",
        "amekujira",
        "2015",
	"<Toolbox>/File/Create/Logos/フェルト地ロゴ",
        "",
        [
        (PF_STRING, "str", "文字", "F"),
        (PF_FONT, "font", "フォント", "Arial Heavy"),
        (PF_SPINNER, "font_size", "フォントの大きさ", 831, (0, 1000, 1)),
        (PF_SPINNER, "font_angle", "回転角", -7, (-90, 90, 0.1)),
        (PF_SPINNER, "font_grow", "拡大距離", 30, (0, 100, 1)),
        (PF_SPINNER, "feather_radius", "境界をぼかす半径", 56, (0, 100, 1)),
        (PF_SPINNER, "font_shrink", "縁取までの距離", 25, (0, 50, 1)),
        (PF_SPINNER, "stitch_width", "縁取の横幅", 7, (0, 50, 1)),
        (PF_SPINNER, "stitch_dist1", "縁取の間隔１", 10, (0, 50, 1)),
        (PF_SPINNER, "stitch_dist2", "縁取の間隔２", 15, (0, 100, 1)),
        (PF_SPINNER,  "hue", "着色する色相)",  275  ,(0,360,1) ),
        (PF_SPINNER,  "saturation", "着色する彩度", 76, (0,100,1) ),
        (PF_SPINNER,  "lightness", "着色する輝度", -13,(-100,100,1) ),
        (PF_SPINNER,  "num_dodgeburn", "暗室回数", 7,(0,100,1) ),
        ],
        [],
        felt_logo)

register(
        "python_fu_felt_logo_alpha",
        "フェルト地ロゴ",
        "フェルト地ロゴ",
        "amekujira",
        "amekujira",
        "2015",
	"<Image>/Filters/Alpha to Logo/フェルト地ロゴ",
        "RGB*, GRAY*",
        [
        (PF_SPINNER, "font_grow", "拡大距離", 30, (0, 100, 1)),
        (PF_SPINNER, "feather_radius", "境界をぼかす半径", 56, (0, 100, 1)),
        (PF_SPINNER, "font_shrink", "縁取りまでの距離", 25, (0, 50, 1)),
        (PF_SPINNER, "stitch_width", "縁取の横幅", 7, (0, 50, 1)),
        (PF_SPINNER, "stitch_dist1", "縁取の間隔１", 10, (0, 50, 1)),
        (PF_SPINNER, "stitch_dist2", "縁取の間隔２", 15, (0, 100, 1)),
        (PF_SPINNER,  "hue", "着色する色相)",  275  ,(0,360,1) ),
        (PF_SPINNER,  "saturation", "着色する彩度", 76, (0,100,1) ),
        (PF_SPINNER,  "lightness", "着色する輝度", -13,(-100,100,1) ),
        (PF_SPINNER,  "num_dodgeburn", "暗室回数", 7,(0,100,1) ),
        ],
        [],
        felt_logo_alpha)

main()
