﻿#!/usr/bin/python
# coding: UTF-8
#メディアンフィルター（ノイズ除去）の円版
#あまりに遅いので速くしようとして読みにくくなった
#画素の近接領域（円か四角形か？）の濃度を小さい順に並べ中央値を出力画素としてるだけ
#濃度はNTSC系加重平均法を使ってみた

from gimpfu import *

class Layer:
 def __init__(self, img=None, lay=None):
  import array
  if img is None:
   img = gimp.image_list()[0]
  if lay is None:
   lay = img.active_layer
  self.img = img
  self.lay = lay
  w = lay.width
  h = lay.height
  self.width = w
  self.height = h
  self.bpp = lay.bpp
  self.rgn = lay.get_pixel_rgn(0,0,w,h,False,False)
  self.rgna = array.array("B", self.rgn[0:w, 0:h])
 def __repr__(self):
  return "%s,bpp=%d,w=%d,h=%d"%(self.lay.__repr__(), self.rgn.bpp, self.lay.width, self.lay.height)
 def get_pixel(self, x, y):
  bpp = self.bpp
  pos = (x + y * self.width) * bpp
  return self.rgna[pos:pos+bpp]
 def get_pos(self, x, y):
  bpp = self.bpp
  pos = (x + y * self.width) * bpp
  return pos
 def update_rgn(self):
  w = self.width
  h = self.height
  self.rgn[0:w, 0:h]=self.rgna.tostring()
  self.lay.visible=not self.lay.visible
  self.lay.visible=not self.lay.visible
 def medianFilter(self, radius, type=0):
  import array
  new_rgna = array.array("B", [0]*len(self.rgna))
  import math
  ntsc = [[0.0 for i in xrange(self.height)] for j in xrange(self.width)]
  for x in xrange(self.width):
   for y in xrange(self.height):
    p = self.get_pixel(x, y)
    ntsc[x][y] = p[0]*0.298912 + p[1]*0.586611 + p[2]*0.114478
  self.ntsc=ntsc
  max_lst = [0 for i in range(radius+1)]
  for r in range(radius+1):
   if type==0:
    max_lst[r] = int(math.floor(math.sqrt(radius**2 - r**2))) #円の場合
   else:
    max_lst[r] = radius #四角の場合
  self.max_lst=max_lst
  for x in xrange(self.width):
   for y in xrange(self.height):
    lst=[]
    append=lst.append
    for y2 in xrange(-radius, radius+1):
     if y2<0:
      max_x = max_lst[-y2]
     else:
      max_x = max_lst[y2]
     for x2 in xrange(-max_x, max_x+1):
      x3=x+x2
      y3=y+y2
      if x3 >= 0 and x3 < self.width and y3 >= 0 and y3 < self.height:
       p=self.get_pixel(x3, y3)
       append([ntsc[x3][y3]+0.0, p])
    lst.sort(key=lambda x: x[0])
    if len(lst) == 0: print "error e1"
    mid=lst[len(lst)/2][1]
    pos = self.get_pos(x,y)
    bpp = self.bpp
    new_rgna[pos:pos+bpp] = mid
  self.rgna = new_rgna

def gimpTime():
 import time
 sttime = time.time()
 img=gimp.image_list()[0];lay=img.active_layer
 pdb.plug_in_despeckle(img, lay, 10, 0, -1, 256)
 return time.time() - sttime

def median(img, draw, radius, type):
 checkTime = False
 import time
 sttime = time.time()
 radius=int(radius)
 pdb.gimp_undo_push_group_start(img)
 a = Layer(img, draw)
 a.medianFilter(radius, type)
 a.update_rgn()
 pdb.gimp_undo_push_group_end(img)
 if checkTime: gimp.message(str(time.time() - sttime))


register(
        "python_fu_median_filter_circle",
        "メディアンフィルター（ノイズ除去）の円版",
        "median filter circle",
        "amekujira",
        "amekujira",
        "2015",
        "<Image>/Filters/Enhance/メディアンフィルター（ノイズ除去）の円版",
        "*",
        [
        (PF_SPINNER, "radius", "半径", 5, (0, 50, 1)),
        (PF_RADIO, "type", "Type:", 0, (("円",0), ("四角",1)) ),
	],
        [],
        median)

main()
