﻿#!/usr/bin/python
# coding: UTF-8
#結合指定したレイヤーもしくはアクティブレイヤーにおいて、選択範囲を移動

from gimpfu import *

def move_sel(img, draw, x, y):
 if pdb.gimp_selection_is_empty(img):
  gimp.message('選択範囲が空')
  return
 act_lay=draw
 pdb.gimp_undo_push_group_start(img)
 save_sel = pdb.gimp_selection_save(img)
 for l in img.layers:
  if l.linked or l==act_lay: #結合指定したレイヤーもしくはアクティブレイヤー
   pdb.gimp_image_select_item(img, CHANNEL_OP_REPLACE, save_sel)
   f = pdb.gimp_selection_float(l,x,y)
   pdb.gimp_floating_sel_anchor(f)
 pdb.gimp_image_select_item(img, CHANNEL_OP_REPLACE, save_sel)
 pdb.gimp_image_remove_channel(img, save_sel)
 pdb.gimp_undo_push_group_end(img)


register(
        "python_fu_move_selection_layers",
        "結合指定したレイヤーもしくはアクティブレイヤーにおいて、選択範囲を移動",
        "move selection at linked or active layers",
        "amekujira",
        "amekujira",
        "2015",
        "<Image>/Layer/選択範囲を移動（複数レイヤー対応）",
        "*",
        [
        (PF_SPINNER, "move_x", "移動距離 X", 0, (-500, 500, 1)),
        (PF_SPINNER, "move_y", "移動距離 Y", 0, (-500, 500, 1)),
	],
        [],
        move_sel)

main()
